import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useState, useLayoutEffect, useEffect } from "react";
import { makeStyles } from "@material-ui/styles";
import LabelButton from "../LabelButton";
import Tooltip from "@material-ui/core/Tooltip";
var useStyles = makeStyles({
  tooltip: {
    whiteSpace: "pre-wrap"
  }
});

var findRouteFromParents = function findRouteFromParents(labelId, labels) {
  if (!labelId) return [];
  var label = labels.find(function (l) {
    return (l.id || "root") === labelId;
  }) || {};

  if (label) {
    return findRouteFromParents(label.parent, labels).concat([labelId]);
  }

  return [labelId];
};

export default (function (_ref) {
  var labels = _ref.labels,
      onSelectLabel = _ref.onSelectLabel;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      parents = _useState2[0],
      changeParents = _useState2[1];

  var currentParent = parents.length > 0 ? parents[parents.length - 1] : undefined;
  var hotkeyLabelMap = {
    r: "root"
  };
  var labelHotkeyMap = {
    root: "r"
  };

  for (var i = 0; i < labels.length; i++) {
    var label = labels[i];
    var letters = (label.displayName || label.id).toLowerCase().split("");
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = letters[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var letter = _step.value;

        if (!hotkeyLabelMap[letter]) {
          hotkeyLabelMap[letter] = label.id;
          labelHotkeyMap[label.id] = letter;
          break;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  useLayoutEffect(function () {
    var eventFunc = function eventFunc(e) {
      if (hotkeyLabelMap[e.key]) {
        var labelId = hotkeyLabelMap[e.key];

        if (!labels.some(function (l2) {
          return l2.parent === labelId;
        })) {
          if (labelId === "root") {
            changeParents([]);
          } else {
            onSelectLabel(labelId);
          }
        } else {
          changeParents(findRouteFromParents(labelId, labels));
        }
      }
    };

    window.addEventListener("keydown", eventFunc);
    return function () {
      window.removeEventListener("keydown", eventFunc);
    };
  });
  var c = useStyles();
  return React.createElement("div", null, labels.some(function (l) {
    return l.parent;
  }) && React.createElement("div", {
    style: {
      alignItems: "center",
      display: "flex",
      flexWrap: "wrap"
    }
  }, React.createElement(LabelButton, {
    small: true,
    color: parents.length > 0 ? "#333" : "#ccc",
    displayName: "Root (r)",
    id: "",
    onClick: function onClick() {
      return changeParents([]);
    }
  }), parents.map(function (p) {
    return labels.find(function (l) {
      return l.id === p;
    });
  }).filter(Boolean).map(function (l) {
    return _objectSpread({}, l, {
      hasChildren: labels.some(function (l2) {
        return l2.parent === l.id;
      })
    });
  }).map(function (l, i) {
    return React.createElement(Tooltip // open={helpOpen}
    , {
      classes: {
        tooltip: c.tooltip
      },
      key: i,
      title: l.description || "No Description",
      placement: "bottom"
    }, React.createElement(LabelButton, Object.assign({
      small: true
    }, l, {
      hotkey: labelHotkeyMap[l.id],
      onClick: function onClick() {
        changeParents(parents.slice(0, parents.indexOf(l.id) + 1));
      }
    })));
  })), React.createElement("div", {
    style: {
      display: "flex",
      alignItems: "center",
      flexWrap: "wrap"
    }
  }, labels.filter(function (l) {
    return l.parent === currentParent;
  }).map(function (l) {
    return _objectSpread({}, l, {
      hasChildren: labels.some(function (l2) {
        return l2.parent === l.id;
      })
    });
  }).map(function (l, i) {
    return React.createElement(Tooltip, {
      key: i,
      classes: {
        tooltip: c.tooltip
      },
      title: l.description || "No Description",
      placement: "bottom"
    }, React.createElement("div", null, React.createElement(LabelButton, Object.assign({}, l, {
      hotkey: labelHotkeyMap[l.id],
      onClick: !l.hasChildren ? onSelectLabel : function () {
        changeParents(parents.concat([l.id]));
      }
    }))));
  })));
});